/* File: 1001 FtrUnregisterPat.c
   ==============================
   DOLATER: COMMENT, FIGURE OUT WHETHER IT'S BETTER TO TRY TO TRAP FTRUNREGISTER?
   
   Written 1999, Douglas I. Anderson (dianders@cs.stanford.edu)

   Hack patch info
   ---------------
   code id:   1001
   atrap:	  A27A (sysTrapFtrUnregister)

   History
   -------
   11/14/99  dia  Created
   03/04/01  dia  Now works with XMaster.
   03/18/01	 dia  Now works with XMaster 1.3 on older OSes; had to move trap
   				  number to 1001 to do this (ugh!)
 */

// ----------------------------------
// Interfaces...
// ----------------------------------

// Silly precompiled harders aren't right on my system--don't really
// need them anyway...
#define PILOT_PRECOMPILED_HEADERS_OFF


/* System-wide */
#include <Pilot.h>
#define NON_PORTABLE
#include <Hardware.h>

/* Hack specific */
#include "GreenLightHack.h"

// ----------------------------------
// Local types...
// ----------------------------------

typedef Err (*FtrUnregisterFn) (DWord creator, UInt featureNum);

// ----------------------------------
// Local function prototypes...
// ----------------------------------

// ----------------------------------
// Trap Handler...
// ----------------------------------

/* Function: MyFtrUnregister()
   ---------------------------
   Patches FtrUnregister() so that I can catch my hack being uninstalled.
 */

Err MyFtrUnregister (DWord creator, UInt featureNum);
Err MyFtrUnregister (DWord creator, UInt featureNum)
{
	Err err;
	FtrUnregisterFn oldTrap = NULL;
	
	err = FtrGet (kCreatorCode, kFtrUnregisterPatchID, (DWord*) &oldTrap);
	if (err) { goto Exit; }

	// WARNING: this relies on the fact that Hackmaster doesn't disable 
	// our trap first.  To be a little safer, we should make sure that we're neither
	// the first or last trap patched...
	// ...note: Xmaster doesn't do 1000 first!
	if ((creator == kCreatorCode)          		   && 
		(featureNum >= 1000 && featureNum <= 1999)   ) 
	{
		HwrBacklight (true /*set*/, false /*value*/);
	}

	err = oldTrap (creator, featureNum);

Exit:
	return err;
}

// ----------------------------------
// Helper functions...
// ----------------------------------






